/*
Function that finds specified item in the given array and return its index
by Faguss (ofp-faguss.com) 09.07.21

Usage:
	[<search for>, <search in>, <optional mode>, <optional starting pos>] call preProcessFile "FindInArray.sqf"
	
Mode argument could be:
	"in" - use "a in [b]" method of comparing instead of "a==b"
	"format" - convert variables to strings before comparing
	"informat" or "formatin" - combine both modes
*/

	

private ["_i", "_index", "_format", "_in", "_start"];
_start  = 0;
_index  = -1;
_in     = false;
_format = false;


// Optional modes
if (count _this > 2) then {
	if ((_this select 2)=="in") then {_in=true};
	if ((_this select 2)=="format") then {_format=true};
	if ((_this select 2)=="formatin" || (_this select 2)=="informat" || (_this select 2)=="format in" || (_this select 2)=="in format") then {_in=true; _format=true};
};
if (_format) then {_this set [0, Format["%1",_this select 0]]};


// Starting index
if (count _this > 3) then {_start=_this select 3; if (_start<0) then {_start=0}};


// Validate arguments
if ((_this select 0) in [(_this select 0)]  &&  !((_this select 1) in [(_this select 1)]) && _start<count (_this select 1)) then {
	_i = 0;
	
	{
		if (_i>=_start  &&  _index==-1) then {
		
			// Use a in [b]
			if (_in) then {
				if ((_this select 0) in [_x]) then {_index=_i}
			} else {
			
				// Compare only if it's scalar
				if (_x in [_x]) then {
				
					// Convert to string
					if (_format) then {_x=Format["%1",_x]};
					
					// Use a==b
					if ((_this select 0) == _x) then {_index=_i}
				}
			}
		};
		
		_i = _i + 1;
	} forEach (_this select 1);
};

_index